
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org GSM Network Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.GSM.Network</h1><h2>Description</h2>
<p>The Network interface is used to give information about the GSM  service providers and this device's status with regards to  to network registration and connectivity.   Taxonomy note: We think in terms of (service) providers  rather than (network) operators, since multiple (service)  providers can use the networks from operators, however  what actually matters most is the provider name, not the  actual network operator the provider is using.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.GSM.Network</tt></p>
<h2>Methods</h2><ul>
<li><a href="#Register">Register</a></li>
<li><a href="#Unregister">Unregister</a></li>
<li><a href="#GetStatus">GetStatus</a></li>
<li><a href="#GetSignalStrength">GetSignalStrength</a></li>
<li><a href="#GetTimeReport">GetTimeReport</a></li>
<li><a href="#ListProviders">ListProviders</a></li>
<li><a href="#RegisterWithProvider">RegisterWithProvider</a></li>
<li><a href="#SetCallingIdentification">SetCallingIdentification</a></li>
<li><a href="#GetCallingIdentification">GetCallingIdentification</a></li>
<li><a href="#SendUssdRequest">SendUssdRequest</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#Status">Status</a></li>
<li><a href="#SignalStrength">SignalStrength</a></li>
<li><a href="#TimeReport">TimeReport</a></li>
<li><a href="#IncomingUssd">IncomingUssd</a></li>
<li><a href="#CipherStatus">CipherStatus</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><i>None</i>
<h1>Methods</h1><h3><a name="Register">Register</a> ( )</h3><p><i>Description:</i> Register with any available service provider. </p><p><div class="rationale"><p>This maps to the GSM 07.07 command +COPS=0, see 3GPP TS 07.07 Chapter 7.3. </p></div></p>
<h3><a name="Unregister">Unregister</a> ( )</h3><p><i>Description:</i> Unregister from service provider. </p>
<h3><a name="GetStatus">GetStatus</a> ( ) &rarr; a{sv}</h3>
<p><i>Description:</i> Get Network Status. </p><h4>Returns</h4><i>a{sv}: status</i><p>Network status information. Mandatory tuples are:  <ul>  <li>( "registration", string ):  <ul> The telephony registration status. Expected values are:  <li>"unregistered" = not registered, not trying,</li>  <li>"home" = registered to home network,</li>  <li>"busy" = not registered, but currently trying,</li>  <li>"denied" = no permitted network available,</li>  <li>"unknown" = no idea,</li>  <li>"roaming" = registered to foreign network.</li>  </ul></li>  <li>( "mode", string ):  <ul>  The registration mode. Expected values are:  <li>"automatic" = automatic selection,</li>  <li>"manual" = manual selection,</li>  <li>"manual;automatic" = manual first, then automatic,</li>  <li>"unregister" = manual unregister,</li>  <li>"unknown" = unknown (this should never occur in production).</li>  </ul></li>  <li>( "act", string ):  <ul>  The network access type. Will default to "GSM" if a modem doesn't support reporting. Expected values are:  <li>"GSM" = GPRS access</li>  <li>"Compact GSM" = </li>  <li>"UMTS" = UMTS access</li>  <li>"EDGE" = Enhanced Data Rates for GSM Evolution </li>  <li>"HSDPA" = High Speed Downlink Packet Access</li>  <li>"HSUPA" = High Speed Uplink Packet Access</li>  <li>"HSDPA/HSUPA" = High Speed Packet Access (both downlink and uplink)</li>  </ul></li>  </ul>  Optional tuples are:  <ul>  <li>( "display", string ): The display name of the network provider (if registered or roaming).</li>  <li>( "provider", string ): The full name of the network provider (if registered or roaming).</li>  <li>( "code", string ): MCC and MNC of the network provider (if registered or roaming).</li>  <ul>  <li>MCC: first three characters starting from the left.</li>  <li>MNC: remaining characters.</li>  </ul>  <li>( "strength", int ): The signal strength in percentage (0-100).</li>  <li>( "lac", string ): The location area code string (if available).</li>  <li>( "cid", string ): The cell id string (if available).</li>  <li>( "pdp.registration", string ): The PDP access registration; values same as telephony registration.  <li>( "pdp.lac", string ): The PDP location area code string (if available).</li>  <li>( "pdp.cid", string ): The PDP cell id string (if available).</li>  </ul> </p>
<h3><a name="GetSignalStrength">GetSignalStrength</a> ( ) &rarr; i</h3>
<p><i>Description:</i> Query the current signal strength, if registered with a service provider. </p><h4>Returns</h4><i>i: signal_strength</i><p>The signal strength in percent (0-100). </p>
<h3><a name="GetTimeReport">GetTimeReport</a> ( ) &rarr; iiii</h3>
<p><i>Description:</i> Query the last received time report. </p><h4>Returns</h4><i>i: time</i><p>The current time in seconds since UNIX epoch.  0, if no time has been received. </p><i>i: timestamp</i><p>Timestamp indicating when the time report has been received from the network. </p><i>i: zone</i><p>The time zone offset in minutes based on UTC.  This value is only valid, if within the interval ( -1440, 1440 ). </p><i>i: zonestamp</i><p>Timestamp indicating when the time report has been received from the network. </p>
<h3><a name="ListProviders">ListProviders</a> ( ) &rarr; a(sssss)</h3>
<p><i>Description:</i> List available service providers. </p><h4>Returns</h4><i>a(sssss): providers</i><p>An array of four-tuples with the following structure:  <ul>  <li>Unique operator code,</li>  <li>Status ("unknown", "available", "current", "forbidden"),</li>  <li>Long Name,</li>  <li>Short Name (optional, may be empty).</li>  <li>Network access type (defaults to "GSM").</li>  </ul> </p>
<h3><a name="RegisterWithProvider">RegisterWithProvider</a> ( s )</h3>
<p><i>Description:</i> Register to a dedicated service provider. </p><h4>Parameters</h4><i>s: operator_code</i><p>The operator code. </p>
<h3><a name="SetCallingIdentification">SetCallingIdentification</a> ( s )</h3>
<p><i>Description:</i> Set whether your subscriber number is visible during a call. </p><h4>Parameters</h4><i>s: status</i><p>One of the following values:  <ul>  <li>"on", if your subscriber number should always be visible to other parties.</li>  <li>"off", if your subscriber number should never be visible to other parties.</li>  <li>"network", if you want to use the network default.</li>  </ul> </p>
<h3><a name="GetCallingIdentification">GetCallingIdentification</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Get whether your subscriber number is visible during a call. </p><h4>Returns</h4><i>s: status</i><p>One of the following values:  <ul>  <li>"on", if your subscriber number is always visible to other parties.</li>  <li>"off", if your subscriber number is never visible to other parties.</li>  <li>"network", if visibility depends on the network settings.</li>  </ul> </p>
<h3><a name="SendUssdRequest">SendUssdRequest</a> ( s )</h3>
<p><i>Description:</i> Send an Unstructured Supplementary Service Data (USSD) request to the network.  Responses will be delivered via the signal <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Network.html#IncomingUssd">IncomingUssd</a> </p><p><div class="rationale"><p>This can map to the GSM 07.07 command +CUSD=1,"(request)",(code), see 3GPP TS 07.07 Chapter 7.14. </p></div></p><h4>Parameters</h4><i>s: request</i><p>The request to be sent to the network. </p>
<h1>Signals</h1><h3><h3><a name="Status">Status</a> ( a{sv} )</h3><p><i>Description:</i> Sent, when the network registration status changes. </p><h4>Parameters</h4><i>a{sv}: status</i><p>The registration status. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Network.html#GetStatus">GetStatus</a> for expected values. </p></h3>
<h3><h3><a name="SignalStrength">SignalStrength</a> ( i )</h3><p><i>Description:</i> (OPTIONAL) Sent, when registered with a service provider and the network signal strength changes. </p><h4>Parameters</h4><i>i: signal_strength</i><p>The signal strength in percent (0-100). </p></h3>
<h3><h3><a name="TimeReport">TimeReport</a> ( ii )</h3><p><i>Description:</i> Sent upon receiving a network time and/or zone report. </p><h4>Parameters</h4><i>i: time</i><p>The current time in seconds since UNIX epoch.  0, if no time has been received. </p><i>i: zone</i><p>The time zone offset in minutes based on UTC.  This value is only valid, if within the interval ( -1440, 1440 ). </p></h3>
<h3><h3><a name="IncomingUssd">IncomingUssd</a> ( ss )</h3><p><i>Description:</i> Sent, when an USSD result or a network initiated request arrives. This signal is usually  sent in response to the method <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.Network.html#SendUssdRequest">SendUssdRequest</a> </p><h4>Parameters</h4><i>s: mode</i><p>The message mode. Valid values are:  <ul>  <li>"completed", if the last user-initiated request has been successfully completed,</li>  <li>"useraction", if this is a network-initiated request and further user action is necessary,</li>  <li>"terminated", if the network terminated the request,</li>  <li>"localclient", if another local client on the network has responded,</li>  <li>"unsupported", if the last user-inititated request is unsupported,</li>  <li>"timeout", if the network has not answered in time.</li>  </ul> </p><i>s: message</i><p>The message. Only set if mode is "completed" or "useraction". "", otherwise. </p></h3>
<h3><h3><a name="CipherStatus">CipherStatus</a> ( ss )</h3><p><i>Description:</i> Sent, when the network reports a change in telephony or PDP cipher indication. </p><h4>Parameters</h4><i>s: telephony</i><p>The telephony cipher: "enabled", "disabled", or "unknown" </p><i>s: pdp</i><p>The PDP cipher cipher: "enabled", "disabled", or "unknown" </p></h3>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

